//+------------------------------------------------------------------+
//|                                                        Multi.mq4 |
//|                                Copyright  2008,   |
//|                                         mailto: urgunt@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,  "
#property link      "mailto: urgunt@gmail.com"

#define Max 6

#property indicator_separate_window
#property indicator_buffers 7

#property indicator_color1 Red
#property indicator_color2 Maroon
#property indicator_color3 Purple
#property indicator_color4 Crimson
#property indicator_color5 DarkOrange
#property indicator_color6 Gold
#property indicator_color7 Yellow
#property indicator_color8 RosyBrown
#property indicator_width1 2
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1

#property indicator_level1 0.0


/*
extern string Pair0 = "USDCADprof";
extern string Pair1 = "USDCHFprof";
extern string Pair2 = "USDHKDprof";
extern string Pair3 = "USDNOKprof";
extern string Pair4 = "USDSEKprof";
extern string Pair5 = "USDSGDprof";
extern string Pair6 = "USDILSprof";
extern string Pair7 = "USDRUBprof";

*/
extern string Pair0 = "USDCAD";
extern string Pair1 = "USDCHF";
extern string Pair2 = "USDHKD";
extern string Pair3 = "USDNOK";
extern string Pair4 = "USDSEK";
extern string Pair5 = "USDSGD";
extern string Pair6 = "USDILS";
extern string Pair7 = "USDRUB";

extern color Pair0Color = Maroon;
extern color Pair1Color = Purple;
extern color Pair2Color = Crimson;
extern color Pair3Color = DarkOrange;
extern color Pair4Color = Gold;
extern color Pair5Color = Yellow;
extern color Pair6Color = RosyBrown;
extern color Pair7Color = Sienna;

double Buf[];
double Buf0[];
double Buf1[];
double Buf2[];
double Buf3[];
double Buf4[];
double Buf5[];
double Buf6[];
//+------------------------------------------------------------------+
int init()
{
	SetIndexBuffer(0,Buf); SetIndexStyle(0,DRAW_HISTOGRAM); 
	SetIndexBuffer(1,Buf0); SetIndexStyle(1,DRAW_SECTION, EMPTY, EMPTY, Pair0Color); SetIndexLabel(1, Pair0);
	SetIndexBuffer(2,Buf1); SetIndexStyle(2,DRAW_SECTION, EMPTY, EMPTY, Pair1Color); SetIndexLabel(2, Pair1);
	SetIndexBuffer(3,Buf2); SetIndexStyle(3,DRAW_SECTION, EMPTY, EMPTY, Pair2Color); SetIndexLabel(3, Pair2);
	SetIndexBuffer(4,Buf3); SetIndexStyle(4,DRAW_SECTION, EMPTY, EMPTY, Pair3Color); SetIndexLabel(4, Pair3);
	SetIndexBuffer(5,Buf4); SetIndexStyle(5,DRAW_SECTION, EMPTY, EMPTY, Pair4Color); SetIndexLabel(5, Pair4);
	SetIndexBuffer(6,Buf5); SetIndexStyle(6,DRAW_SECTION, EMPTY, EMPTY, Pair5Color); SetIndexLabel(6, Pair5);
	SetIndexBuffer(7,Buf6); SetIndexStyle(7,DRAW_SECTION, EMPTY, EMPTY, Pair6Color); SetIndexLabel(7, Pair6);
	return(0);
}
//+------------------------------------------------------------------+
int deinit() { return(0); }
//+------------------------------------------------------------------+
int start()
{
	string Pair[8]; //       
	Pair[0]=Pair0; Pair[1]=Pair1; Pair[2]=Pair2; Pair[3]=Pair3; 
	Pair[4]=Pair4; Pair[5]=Pair5; Pair[6]=Pair6; Pair[7]=Pair7; 
	color PairClr[8];  //       
	PairClr[0]=Pair0Color; PairClr[1]=Pair1Color; PairClr[2]=Pair2Color; PairClr[3]=Pair3Color;
	PairClr[4]=Pair4Color; PairClr[5]=Pair5Color; PairClr[6]=Pair6Color; PairClr[7]=Pair7Color;
	
	int bar0, bar1; string str; datetime time0, time;
	int i, j, k, delta, bb;
	double pc0, pc, a, Sum;
	int bar=iBars(Pair[0], 0); for (j=1; j<Max; j++)	bar=MathMin(bar, iBars(Pair[j], 0)); //    
	for (i=0; i<bar; i++)
	{
		time=iTime(Symbol(), 0, i); //    (   )
		//    
		k=0; bar1=0; while (k<Max && bar1!=-1)  { bar1=iBarShift(Pair[k], 0, time, true);  k++; }
		if (bar1==-1) continue;

		str=TimeYear(time)+"."+TimeMonth(time)+"."+TimeDay(time);	time0=StrToTime(str);
		//   
		k=0; bar0=0; while (k<Max && bar0!=-1)  { bar0=iBarShift(Pair[k], 0, time0, true);  k++; }
		if (bar0==-1) continue;

		//   
		k=0; pc0=1;	while (k<Max && pc0!=0)  { pc0=iClose(Pair[k], 0, bar0+1);  k++; }
		if (pc0==0) continue;
		Sum=0;
		for (j=0; j<Max; j++)
		{
			bar0=iBarShift(Pair[j], 0, time0, true); bar1=iBarShift(Pair[j], 0, time, true);
			delta=iBarShift(Symbol(), 0, time, true)-bar1;
			pc0=iClose(Pair[j], 0, bar0+1); pc=iClose(Pair[j], 0, bar1);
			a=pc/pc0*100-100;
			Sum=Sum+a;
			if (j==0) if (Pair[j]==Symbol()) { Buf0[bar1]=a; bb=bar1; } else Buf0[bar1+delta]=a; 
			if (j==1) if (Pair[j]==Symbol()) { Buf1[bar1]=a; bb=bar1; } else Buf1[bar1+delta]=a; 
			if (j==2) if (Pair[j]==Symbol()) { Buf2[bar1]=a; bb=bar1; } else Buf2[bar1+delta]=a; 
			if (j==3) if (Pair[j]==Symbol()) { Buf3[bar1]=a; bb=bar1; } else Buf3[bar1+delta]=a; 
			if (j==4) if (Pair[j]==Symbol()) { Buf4[bar1]=a; bb=bar1; } else Buf4[bar1+delta]=a; 
			if (j==5) if (Pair[j]==Symbol()) { Buf5[bar1]=a; bb=bar1; } else Buf5[bar1+delta]=a; 
			if (j==6) if (Pair[j]==Symbol()) { Buf6[bar1]=a; bb=bar1; } else Buf6[bar1+delta]=a; 
		}
		Buf[bar1]=Sum;
	}
	/*
	int w=WindowFind("!MultiUX");	if (w==-1) w=0;
	for (j=0; j<Max; j++)
		if (ObjectFind(Pair[j])==-1)
		{
			ObjectCreate(Pair[j], OBJ_LABEL, w, 0, 0); ObjectSet(Pair[j], OBJPROP_CORNER, 1);
			ObjectSet(Pair[j], OBJPROP_XDISTANCE, 1); ObjectSet(Pair[j], OBJPROP_YDISTANCE, 1+(15*(j+5))); 
			ObjectSetText(Pair[j], Pair[j], 8, "Arial"); ObjectSet(Pair[j], OBJPROP_COLOR, PairClr[j]);
		}
		
		
	*/	
	return(0);
}

